#include <iostream>
#include <algorithm>
#include "util.h"

int
main ()
{
    SWFDisplayItem *di;
    SWFButton *b;

    Ming_init ();

    SWFMovie *the_movie = new SWFMovie ();
    const int movie_width = 2 * GRID_X + LARG * GRID_SIZE;

    ////////////////////////// Frame 1: popup, functions, global variables
    SWFSprite *popup = progress_popup ("Le calcul de certaines "
                                       "probabilits de transition "
                                       "est en cours et permettra "
                                       "d'acclrer le droulement "
                                       "de l'algorithme.\nMerci de "
                                       "votre patience.");
    di = the_movie->add (popup);
    int c = (movie_width - 300) / 2 - 2;
    di->move (c, c);
    di->setName ("popup");
    di->setDepth (30);

    the_movie->add (new SWFAction (MAP_STR "\n\
nb_of_cells = grid_width * grid_height;\n\
grid_size = "GRID_SIZE_STR";\n\
\n\
colors = new Array (nb_of_cells);\n\
b = new Array (nb_of_cells);\n\
bnn = new Array (nb_of_cells); // b non normalis\n\
obs = new Array (4);\n\
\n\
function colorize_cell (cell_index, proba, is_alledged_pos)\n\
 {\n\
//    colors[i].setRGB (65536 * r + 256 * g + b);\n\
    if (is_alledged_pos)\n\
    {\n\
        t = Math.floor (150 + 105 * proba);\n\
        colors[cell_index].setRGB (t * 65792); // yellow t t 0\n\
        return;\n\
    }\n\
\n\
    if (proba == 0)\n\
        colors[cell_index].setRGB (16763080); // light red 255 200 200\n\
    else\n\
        colors[cell_index].setRGB (Math.floor (255 - 362 * Math.sqrt (proba)) * 65793); // gray t t t\n\
}\n\
\n\
function can_not_go (from, to)\n\
 {\n\
    return to < 0 ||\n\
        to >= nb_of_cells ||\n\
        map[to] == 0 ||\n\
        (Math.abs ((to % grid_width) - (from % grid_width)) +\n\
         Math.abs (Math.floor (to / grid_width) - Math.floor (from / grid_width))\n\
         > 2);\n\
}\n\
\n\
function log_frame ()\n\
 {\n\
      foo = 0;\n\
}\n\
\n\
normal_move_offset = new Array (1, -grid_width, -1, grid_width);\n\
\n\
function is_there_a_wall (cell, direction)\n\
 {\n\
    return can_not_go (cell, cell + normal_move_offset [direction]);\n\
}\n\
\n\
origin_matrix = new Array (4);\n\
move_proba  = new Array (70, 10, 10, 10);\n\
"));

    the_movie->nextFrame ();
    ////////////////////////// End of First Frame ////////////////////

    ////////////////////////// Frame 2 to 5: lengthy computations
    char action[2000]; // Make sure it 's long enough. (snprintf return value ?)

    for (int i = 1; i < 5; i++)
    {
        snprintf (action, sizeof action,"\n\
direction = %d;\n\
origin_matrix[ direction ] = new Array (nb_of_cells);\n\
\n\
if (direction == 0)\n\
    move_offset = new Array (1, 0, -grid_width+1, grid_width+1);\n\
else if (direction == 1)\n\
    move_offset = new Array (-grid_width, 0, -grid_width-1, -grid_width+1);\n\
else if (direction == 2)\n\
    move_offset = new Array (-1, 0, grid_width-1, -grid_width-1);\n\
else if (direction == 3)\n\
    move_offset = new Array (grid_width, 0, grid_width+1, grid_width-1);\n\
\n\
for (cell = 0; cell < nb_of_cells; cell++)\n\
 {\n\
    if (map[ cell ] == 0)\n\
        continue;\n\
\n\
    origin_matrix[ direction ][ cell ] = new Array ();\n\
\n\
    valid_origin = 0;\n\
 \n\
    for (origin = 0; origin < 4; origin++) // 4 = move_offset.length\n\
    {\n\
        cwicf = cell - move_offset[origin]; // cell_where_i_come_from\n\
        if (can_not_go (cell, cwicf))\n\
            continue;\n\
\n\
        sum_proba = move_proba[ origin ];\n\
        for (i = 0; i < 4; i++)\n\
        {\n\
            if (i == origin)\n\
                continue;\n\
                    \n\
            if (can_not_go (cwicf, cwicf + move_offset[i]))\n\
                continue;\n\
            sum_proba += move_proba[i];\n\
        }\n\
        proba = move_proba[ origin ] / sum_proba;\n\
        origin_matrix[ direction ][ cell ][ valid_origin ] = \n\
            { cell_index: cwicf, transition_proba: proba };\n\
        valid_origin++;\n\
    }\n\
}\n\
\n\
popup.progress%d._visible = false;\n\
popup.progress%d._visible = true;\n\
popup.bar._xscale = %d;",
                            i - 1,
                            i - 1, i, i * 25);

        the_movie->add (new SWFAction (action));

        the_movie->nextFrame ();
        ////////////////////// End of Frames 2 to 5 //////////////////
    } // end of for loop

    ////////////////////////// Frame 6: remove popup, add the grid and others
    SWFSprite *grid = the_grid (LARG, HAUT);
    di = the_movie->add (grid);
    di->moveTo (GRID_X, GRID_Y);
    di->setDepth (2);
    di->setName ("grid");
    di->addAction (new SWFAction ("\n\
if (_root.UI_dragging)\n\
 {\n\
    x = Math.floor (_xmouse / _root.grid_size);\n\
    y = Math.floor (_ymouse / _root.grid_size);\n\
    \n\
    x = (x < 0 ? 0 : x);\n\
    x = (x >= _root.grid_width ? _root.grid_width - 1 : x);\n\
    y = (y < 0 ? 0 : y);\n\
    y = (y >= _root.grid_height ? _root.grid_height - 1 : y);\n\
   \n\
    s = x + _root.grid_width * y;\n\
    if (_root.map[ s ] == 0)\n\
        return;\n\
\n\
    drag_position = s;\n\
\n\
    if (_root.b[ s ] == 0)\n\
        robot._alpha = 50;\n\
    else\n\
        robot._alpha = 100;\n\
\n\
    robot._x = _root.grid_size * x;\n\
    robot._y = _root.grid_size * y;\n\
}\n\
"),
                   SWFACTION_MOUSEMOVE);
    di->addAction (new SWFAction("\n\
if (_root.UI_dragging)\n\
 {\n\
    robot._alpha = 100;\n\
    _root.UI_dragging = false;\n\
    _root.robot_position = drag_position;\n\
}\n\
"),
                  SWFACTION_MOUSEUP);

    // Reset button
    int y = GRID_Y + HAUT * GRID_SIZE + GRID_Y;
    int mid_x = GRID_X + 50 + 10;

    b = a_button (50, 25, 5, "\n\
if (!UI_playing)\n\
  gotoandstop (7);\n\
", "Reset");
    di = the_movie->add (b);
    di->move (GRID_X, y);

    SWFText *t;
    t = a_caption ("Reinitialize the game");
    di = the_movie->add (t);
    di->move (mid_x, y + 17.5);

    // Step button
    y += 25 + 10;

    b = a_button (50, 25, 5, "\n\
if (!UI_playing && !UI_done)\n\
 {\n\
  UI_keep_playing = false;\n\
  gotoandplay (8);\n\
}\n\
", "Step");
    di = the_movie->add (b);
    di->move (GRID_X, y);

    t = a_caption ("Perform one iteration");
    di = the_movie->add (t);
    di->move (mid_x, y + 17.5);

    // Play button
    y += 35;

    b = a_button (50, 25, 5, "\n\
if (!UI_playing && !UI_done)\n\
 {\n\
  UI_keep_playing = true;\n\
  gotoandplay (8);\n\
}\n\
", "Play");
    di = the_movie->add (b);
    di->move (GRID_X, y);

    t = a_caption ("Iterate repeatedly");
    di = the_movie->add (t);
    di->move (mid_x, y + 17.5);

    // Pause button
    y += 35;
    
    b = a_button (50, 25, 5, "UI_keep_playing = false;", "Pause");
    di = the_movie->add (b);
    di->move (GRID_X, y);

    t = a_caption ("Stop iterating");
    di = the_movie->add (t);
    di->move (mid_x, y + 17.5);

    // Toggle button
    y += 35;

    b = a_button (50, 25, 5,
                  "grid.arrows._visible = !grid.arrows._visible;",
                  "Toggle");
    di = the_movie->add (b);
    di->move (GRID_X, y);

    t = a_caption ("Show/Hide arrows");
    di = the_movie->add (t);
    di->move (mid_x, y + 17.5);
    
    // a line
    y = 2 * GRID_Y + HAUT * GRID_SIZE;

    SWFShape *line = new SWFShape ();
    line->setLine (1, 0, 0, 0);
    line->movePen (210, y);
    line->drawLine (0, 5 * 35 - 10);
    the_movie->add (line);

    // What the robot sees
    t = a_caption ("The walls the robot sees:");
    di = the_movie->add (t);
    di->move (230, y + 28);
    
    SWFSprite *vision = vision_robot ();
    di = the_movie->add (vision);
    di->moveTo (380, y + 3);
    di->setName ("vision");

    // Fast button
    y += 2 * 35;

    b = a_button (50, 25, 5, "UI_anim_steps = 2;", "Fast");
    di = the_movie->add (b);
    di->move (230, y);
    
    // Normal button
    y += 35;

    b = a_button (50, 25, 5, "UI_anim_steps = 4;", "Normal");
    di = the_movie->add (b);
    di->move (230, y);
    t = a_caption ("Set animation speed");
    di = the_movie->add (t);
    di->move (290, y + 17.5);
    
    // Slow button
    y += 35;

    b = a_button (50, 25, 5, "UI_anim_steps = 8;", "Slow");
    di = the_movie->add (b);
    di->move (230, y);
    

//     SWFFont *f = new SWFFont ("_sans");
//     SWFTextField *tf = new SWFTextField ();
//     tf->setFlags (SWFTEXTFIELD_NOEDIT |
//                   SWFTEXTFIELD_WORDWRAP |
//                   SWFTEXTFIELD_DRAWBOX |
//                   SWFTEXTFIELD_MULTILINE);
//     tf->setFont (f);
//     tf->setVariableName ("logHere");
//     tf->setBounds (movie_width - 2 * GRID_X, 200);
//     tf->setHeight (12);
//     di = the_movie->add (tf);
//     di->moveTo (GRID_X, y + 25 + GRID_Y);

    the_movie->add (new SWFAction ("\n\
popup._visible = false;\n\
grid._visible = false;\n\
\n\
vision_colors = new Array (4);\n\
vision_colors[0] = new Color (\"vision.wall0\");\n\
vision_colors[1] = new Color (\"vision.wall1\");\n\
vision_colors[2] = new Color (\"vision.wall2\");\n\
vision_colors[3] = new Color (\"vision.wall3\");\n\
\n\
cell_name = \"grid.cell_\";\n\
arrow_name = \"grid.arrows.arrow_\";\n\
accessible_cells = 0;\n\
for (i = 0; i < nb_of_cells; i++)\n\
 {\n\
    colors[i] = new Color (cell_name.concat (i));\n\
\n\
    the_arrow = eval (arrow_name.concat (i));\n\
    if (map[i] != 0)\n\
    {\n\
        accessible_cells++;\n\
        the_arrow._rotation = -90 * (map[i] - 1);\n\
    }\n\
    else\n\
        the_arrow._visible = false;\n\
}\n\
\n\
UI_anim_steps = 4;\n\
"));

    the_movie->nextFrame ();
    ////////////////////////// End of Sixth Frame ////////////////////

    ////////////////////////// Frame 7: initializations (no creation)
    the_movie->add (new SWFAction ("\n\
grid._visible = true;\n\
nb_of_iterations = 0;\n\
\n\
grid.robot._x = (start_case % grid_width) * grid_size;\n\
grid.robot._y = Math.floor(start_case / grid_width) * grid_size;\n\
\n\
grid.flag._x = (target_case % grid_width) * grid_size + 9;\n\
grid.flag._y = (Math.floor(target_case / grid_width)) * grid_size + 5;\n\
\n\
for (i = 0; i < nb_of_cells; i++)\n\
 {\n\
    bnn[i] = 0;\n\
\n\
    if (i == start_case)\n\
        b[i] = 1;\n\
    else\n\
        b[i] = 0;\n\
\n\
    if (map[i] != 0)\n\
        colorize_cell (i, b[i], i == start_case);\n\
    else\n\
        colors[i].setRGB (0); // black\n\
}\n\
\n\
robot_position = start_case;\n\
grid.robot.gotoandstop (map[start_case]);\n\
alledged_pos = start_case;\n\
\n\
for (i = 0; i < 4; i++)\n\
    vision_colors[i].setRGB (65793 * 127);\n\
vision.go._alpha = 60;\n\
vision.bump._alpha = 60;\n\
\n\
UI_playing = false;\n\
UI_keep_playing = true; // but it's useless to set its value\n\
UI_done = false;\n\
UI_dragging = false;\n\
\n\
stop ();\n\
"));

    the_movie->nextFrame ();
    ////////////////////////// End of Seventh Frame //////////////////

    ////////////////////////// Frame 8: one iteration
    ////////////////////////// take an action, initialize the show the
    ////////////////////////// result/compute new probabilities-mix
    the_movie->add (new SWFAction ("\n\
UI_playing = true;\n\
robot_move_anim_steps = UI_anim_steps;\n\
\n\
/// Take the action\n\
\n\
action = map[alledged_pos] - 1; // keep it in [0..3]\n\
grid.robot.gotoandstop (action + 1);\n\
\n\
if (action == 0)\n\
    move_offset = new Array (1, 0, -grid_width+1, grid_width+1);\n\
else if (action == 1)\n\
    move_offset = new Array (-grid_width, 0, -grid_width-1, -grid_width+1);\n\
else if (action == 2)\n\
    move_offset = new Array (-1, 0, grid_width-1, -grid_width-1);\n\
else if (action == 3)\n\
    move_offset = new Array (grid_width, 0, grid_width+1, grid_width-1);\n\
\n\
// See which moves are possible\n\
move_proba  = new Array (70, 10, 10, 10);\n\
for (i = 0; i < move_offset.length; i++)\n\
 {\n\
    if (can_not_go (robot_position, robot_position + move_offset[i]))\n\
    {\n\
        move_offset.splice (i, 1);\n\
        move_proba.splice (i, 1);\n\
        i--;\n\
    }\n\
}\n\
// OK, choose the result of the action\n\
sum = 0;\n\
for (i = 0; i < move_proba.length; i++)\n\
    sum += move_proba[i];\n\
\n\
t = Math.floor (sum * Math.random ());\n\
for (i = 0; i < move_proba.length; i++)\n\
 {\n\
    if (t < move_proba[i])\n\
        break;\n\
\n\
    t -= move_proba[i];\n\
}\n\
robot_position += move_offset[i];\n\
\n\
// Compute what the robot sees\n\
\n\
is_chocked = is_there_a_wall (robot_position, action);\n\
if (is_chocked)\n\
 {\n\
    for (i = 0; i < 4; i++)\n\
    {\n\
        if (i == action)\n\
        {\n\
            if (Math.random () < 0.45) // erreur\n\
                obs[i] = false;\n\
            else\n\
                obs[i] = true;\n\
        }\n\
        else\n\
        {\n\
            if (Math.random () < 0.35) // erreur\n\
                obs[i] = ! is_there_a_wall (robot_position, i);\n\
            else\n\
                obs[i] = is_there_a_wall (robot_position, i);\n\
        }\n\
    }\n\
}\n\
else\n\
    for (i = 0; i < 4; i++)\n\
        obs[i] = is_there_a_wall (robot_position, i);\n\
\n\
// Recompute the observation probabilities\n\
total_proba = 0;\n\
robot_move_anim_iter = 0;\n\
robot_move_delta_x = (robot_position % grid_width) * grid_size - grid.robot._x;\n\
robot_move_delta_y = Math.floor (robot_position / grid_width) * grid_size - grid.robot._y;\n\
s = 0;\n\
"));
    the_movie->nextFrame ();
    ////////////////////////// End of Eight frame ////////////////////
    ////////////////////////// Frame 9: do one step in computing/advancing

    the_movie->add (new SWFAction ("\n\
robot_move_anim_iter++;\n\
\n\
for (; s < nb_of_cells / robot_move_anim_steps * robot_move_anim_iter; s++)\n\
 {\n\
    if (map[s] == 0)\n\
        continue;\n\
\n\
    if (s == target_case && robot_position != target_case)\n\
    {\n\
        bnn[s] = 0; // kind of optimisation\n\
        continue;\n\
    }\n\
\n\
    o = 1;\n\
\n\
    if (is_there_a_wall (s, action)) // would_be_chocked\n\
    {\n\
        for (i = 0; i < 4; i++)\n\
        {\n\
            if (i == action)\n\
                o *= ((obs[i] == true) ? 0.55 : 0.45);\n\
            else\n\
                o *= ((obs[i] == is_there_a_wall (s, i)) ? 0.65 : 0.35);\n\
        }\n\
    }\n\
    else // is fine. Must see what it sees\n\
    {\n\
        for (i = 0; i < 4 && o == 1; i++)\n\
        {\n\
            if (i == action)\n\
                o = ((obs[i] == false) ? 1 : 0);\n\
            else\n\
                o = ((obs[i] == is_there_a_wall (s, i)) ? 1 : 0);\n\
        }\n\
    }\n\
\n\
    if (o == 0)\n\
    {\n\
        bnn[s] = 0;\n\
        continue;\n\
    }\n\
\n\
    bnn[s] = 0;\n\
    l = origin_matrix[ action ][ s ].length;\n\
    for (i = 0; i < l; i++)\n\
    {\n\
        bnn[s] += b[ origin_matrix[ action ][ s ][ i ][ \"cell_index\" ] ]\n\
            * origin_matrix[ action ][ s ][ i ][ \"transition_proba\" ];\n\
    }\n\
    bnn[s] *= o;\n\
\n\
    total_proba += bnn[s];\n\
}\n\
\n\
if (robot_move_delta_x == 0 && robot_move_delta_y == 0)\n\
 {\n\
    if (robot_move_anim_iter < robot_move_anim_steps)\n\
    {\n\
        grid.robot._x = (robot_position % grid_width + Math.random() * 0.4 - 0.2) * grid_size;\n\
        grid.robot._y = (Math.floor (robot_position / grid_width) + Math.random () * 0.4 - 0.2) * grid_size;\n\
    }\n\
    else\n\
    {\n\
        grid.robot._x = (robot_position % grid_width) * grid_size;\n\
        grid.robot._y = Math.floor (robot_position / grid_width) * grid_size;\n\
    }\n\
    \n\
}\n\
else\n\
 {\n\
    grid.robot._x += robot_move_delta_x / robot_move_anim_steps;\n\
    grid.robot._y += robot_move_delta_y / robot_move_anim_steps;\n\
}\n\
\n\
if (robot_move_anim_iter == robot_move_anim_steps)\n\
 {\n\
    // show what the robot sees\n\
    for (i = 0; i < 4; i++)\n\
        if (obs[i])\n\
            vision_colors[i].setRGB (0);\n\
        else\n\
            vision_colors[i].setRGB (65793 * 196);\n\
\n\
    if (is_chocked)\n\
    {\n\
        vision.go._alpha = 40;\n\
        vision.bump._alpha = 100;\n\
    }\n\
    else\n\
    {\n\
        vision.go._alpha = 100;\n\
        vision.bump._alpha = 30;\n\
    }\n\
\n\
    if (total_proba == 0)\n\
    {\n\
        alledged_pos = Math.floor (nb_of_cells * Math.random ());\n\
        while (map[alledged_pos] == 0)\n\
            alledged_pos = Math.floor (nb_of_cells * Math.random ());\n\
        \n\
        logHere += \"Robot is lost ! It is  reinitializing in cell (\" +\n\
                   (alledged_pos % grid_width + 1) + \",\" +\n\
                   Math.floor (alledged_pos / grid_width + 1) + \").\\n\";\n\
        epsilon = 0.01;\n\
        for (s = 0; s < nb_of_cells; s++)\n\
        {\n\
            if (map[s] == 0)\n\
                continue;\n\
\n\
            if (s == alledged_pos)\n\
                b[s] = (1 - epsilon) / accessible_cells + epsilon;\n\
            else\n\
                b[s] = (1 - epsilon) / accessible_cells;\n\
\n\
            colorize_cell (s, b[s], s == alledged_pos);\n\
        }\n\
    }\n\
    else\n\
    {\n\
        alledged_pos = 0;\n\
        its_proba = 0;\n\
\n\
        for (s = 0; s < nb_of_cells; s++)\n\
        {\n\
            if (map[s] == 0)\n\
                continue;\n\
\n\
            b[s] = bnn[s] / total_proba;\n\
            if (b[s] > its_proba)\n\
            {\n\
                alledged_pos = s;\n\
                its_proba = b[s];\n\
            }\n\
            colorize_cell (s, b[s], false);\n\
        }\n\
        colorize_cell (alledged_pos, its_proba, true);\n\
    }\n\
} // if it's the last anim step\n\
"));

    the_movie->nextFrame ();
    ////////////////////////// End of Ninth Frame ////////////////////

    the_movie->add (new SWFAction ("\n\
if (robot_move_anim_iter < robot_move_anim_steps)\n\
    gotoandplay (9);\n\
else\n\
 {\n\
    nb_of_iterations++;\n\
\n\
    if (robot_position != target_case)\n\
    {\n\
        if (UI_keep_playing)\n\
            gotoandplay (8);\n\
        else\n\
        {\n\
            UI_playing = false;\n\
            stop ();\n\
        }\n\
    }\n\
    else\n\
    {\n\
        grid.flag._y -= 0.65 * grid_size;\n\
        logHere += \"Robot found its way to the end in \" + nb_of_iterations\n\
            + \" moves. Hooray ! \\n\";\n\
        UI_done = true;\n\
        UI_playing = false;\n\
        stop ();\n\
    }\n\
}\n\
"));

    the_movie->nextFrame ();
    ////////////////////////// End of Tenth (sort of fake) Frame//////

    the_movie->setDimension (movie_width,
                             3 * GRID_Y + HAUT * GRID_SIZE + 5 * 35 - 10);
    the_movie->setRate (10);
    the_movie->save ("final.swf");
    std::cout << "Taille : " << movie_width << "x" << 3 * GRID_Y + HAUT * GRID_SIZE + 5 * 35 - 10 << "." << std::endl;
    return 0;
}
